# using docker in docker is necessary when utilizing shared runners, but is a bad practise for production:
# https://jpetazzo.github.io/2015/09/03/do-not-use-docker-in-docker-for-ci/
# for an alternative when using private runners see:
# https://angristan.xyz/build-push-docker-images-gitlab-ci/

image: docker:stable

stages:
  - build
  - deploy

variables:
  DEV_ENV: dev
  KUBERNETES_BASE_NAMESPACE: gitlab

docker build:
  stage: build
  services:
    - docker:dind
  only:
    - master
  before_script:
    - docker login registry.gitlab.com -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD}
  script:
  # TODO: avoid using latest to enable rollbacks in GitLab
    - docker build -t ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest ./app
    - docker push ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest
  after_script:
    - docker logout ${CI_REGISTRY}
  tags:
    - docker

deploy_dev:
  image: lwolf/kubectl_deployer:latest
  stage: deploy
  environment:
    name: $DEV_ENV
    # see https://docs.gitlab.com/ee/ci/environments.html#configuring-kubernetes-deployments:
    # will not be effective if cluster is managed by GitLab
    kubernetes:
      namespace: $KUBERNETES_BASE_NAMESPACE
  script:
    - kubectl apply -f deploy_app.yaml